<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="initial-scale=1.0, user-scalable=no">
    <meta charset="utf-8">
    <title>Corona Help Others</title>
	<script defer src="https://unpkg.com/@google/markerclustererplus@4.0.1/dist/markerclustererplus.min.js"></script>
    <script async defer
    src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCTWa-MsmpxM5I3ndoqBc23zbTznzIXgBs">
    </script>
    <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <style>
      /* Always set the map height explicitly to define the size of the div
       * element that contains the map. */
      #map {
        height: 96%;
      }
      /* Optional: Makes the sample page fill the window. */
      html, body {
        height: 96%;
        margin: 0;
        padding: 0;
      }
    </style>
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <link rel="stylesheet" type="text/css" href="css/main.css">
	
  </head>
  <body>
    <nav class="navbar navbar-inverse">
         <div class="container-fluid">
            <div class="navbar-header">
               <a class="navbar-brand" href="#">Cornona Help Others</a>
            </div>
            <ul class="nav navbar-nav navbar-right">
				<li><a href="./index.html">See Help Seekers in Map</a></li>
				<li class='active'><a href="#">See Volunteers in Map</a></li>
				<li><a href="./help_seekers_list.html">Help Seekers</a></li>
               <li><a href="./volunteers_list.html">Volunteers</a></li>
            </ul>
         </div>
      </nav>
    <div id="map"></div>
	<footer class="page-footer font-large black">
         <div class="footer-copyright text-center py-5">© 2020 Copyright:
            <a href="https://onefourthlabs.com"> Made with ❤ by One Fourth Labs</a>
         </div>
    </footer>
    <script>


	var volunteers;

	function fetch_volunteers_data(){
		$.ajax({
			url: 'https://db-server-dot-corona-bot-gbakse.appspot.com/get_all_volunteers',
			type: 'get',
			success: function(response){
				volunteers = response;
				console.log("volunteers",volunteers);
				initMap();
			}
		});
	}


    function initMap() {

        var map = new google.maps.Map(document.getElementById('map'), {
          zoom: 5,
          center: {lat: 23.2599, lng: 77.4126} // Bhopal
        });

        var max_distance = 10 * 1000; // in M
        var display_info = 'false';

        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
            var current_pos = {
              lat: position.coords.latitude,
              lng: position.coords.longitude
            };
            map.setCenter(current_pos);
            map.setZoom(12)

            var access_area = new google.maps.Circle({
				strokeColor: '#FF0000',
				strokeOpacity: 0.8,
				strokeWeight: 2,
				fillColor: '#FF0000',
				fillOpacity: 0.35,
				map: map,
				center: current_pos,
				radius: max_distance // in M
			});

			set_volunteer_markers("true", current_pos);
			//set_help_seeker_markers("true", current_pos);

          }, function() {
            handleLocationError(true, map.getCenter());
            set_volunteer_markers("false", "false");
            //set_help_seeker_markers("false", "false");
          });
        } else {
          // Browser doesn't support Geolocation
          	handleLocationError(false, map.getCenter());
        	set_volunteer_markers("false", "false");
        	//set_help_seeker_markers("false", "false");
        }

        function handleLocationError(browserHasGeolocation, pos) {
	        let error_message = browserHasGeolocation ?
	                              'Error: The Geolocation service failed.' :
	                              'Error: Your browser doesn\'t support geolocation.';
	        window.alert(error_message);
      	}

      	function find_haversine_distance(lat1,lon1,lat2,lon2) {
			var R = 6371; // km (change this constant to get miles)
			var dLat = (lat2-lat1) * Math.PI / 180;
			var dLon = (lon2-lon1) * Math.PI / 180;
			var a = Math.sin(dLat/2) * Math.sin(dLat/2) +
				Math.cos(lat1 * Math.PI / 180 ) * Math.cos(lat2 * Math.PI / 180 ) *
				Math.sin(dLon/2) * Math.sin(dLon/2);
			var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a));
			var d = R * c;
			//if (d>1) return Math.round(d)+"km";
			//else if (d<=1) return Math.round(d*1000)+"m";
			return Math.round(d*1000); //return distance in m
		}

        
        function set_volunteer_markers(display_info, user_position) {
        	// Add some markers to the map.
	        // Note: The code uses the JavaScript Array.prototype.map() method to
	        // create an array of markers based on a given "locations" array.
	        // The map() method here has nothing to do with the Google Maps API.
	        var volunteer_markers = volunteers.map(function(entry, i) {

				let loc = {
					lat: parseFloat(entry['lat']),
					lng: parseFloat(entry['long'])
				}

				var contentString = ''+
					'<p>'+
					'	<h3>'+entry['help_category']['main']+'</h3>'+
					'	<h5>'+entry['help_category']['sub']+'</h3>'+
					'	Datetime: '+entry['datetime'] + '<br>' +
					'	Name: '+entry['name']+'<br>' +
					'	Phone: '+entry['phone']+'<br>' +
					'	Email: '+entry['email']+'<br>' +
					'	Report: '+ entry['report_message'] +
					'</p>';

				var infowindow = new google.maps.InfoWindow({
				  content: contentString
				});

				icon_url = "https://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=%E2%80%A2|0000ff"
				var marker = new google.maps.Marker({
					position: loc, 
					label: entry['name'],
					icon: icon_url
				});

				//console.log(current_pos)
				if (display_info) {
					let haversine_distance = find_haversine_distance(user_position.lat, user_position.lng, loc.lat, loc.lng)
					//console.log(haversine_distance, max_distance)
					if (haversine_distance <= max_distance) {
						marker.addListener('click', function() {
				          infowindow.open(map, marker);
				    	});
					}
				}
			
          	return marker
        	});

        	// Add a marker clusterer to manage the markers.
        	var markerCluster = new MarkerClusterer(map, volunteer_markers,
            {imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m', maxZoom:18});
    	}


    }
        
    fetch_volunteers_data();

    </script>
    
  </body>
</html>
